/***************************************************************************
 *   Copyright (C) 2005-2008 by the FIFE team                              *
 *   http://www.fifengine.de                                               *
 *   This file is part of FIFE.                                            *
 *                                                                         *
 *   FIFE is free software; you can redistribute it and/or                 *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA          *
 ***************************************************************************/

#ifndef FIFE_ANIMATION_POOL_H
#define FIFE_ANIMATION_POOL_H

// Standard C++ library includes

// 3rd party library includes

// FIFE includes
// These includes are split up in two parts, separated by one empty line
// First block: files included from the FIFE root src directory
// Second block: files included from the same folder
#include "animation.h"

#include "util/resource/pool.h"

namespace FIFE {
	class Animation;

	/**  Pool for holding images
	 */
	class AnimationPool: public Pool {
	public:
		/** Default constructor.
		 */
		AnimationPool(const std::string& name = "AnimationPool"): Pool(name) {
		}

		/** Destructor.
		 */
		virtual ~AnimationPool() {}

		inline Animation& getAnimation(unsigned int index)  {
			return static_cast<Animation&>(get(index));
		}
	};

} //FIFE

#endif
